package test;

import geocode.APIManager;
import geocode.GeoData;

import java.util.List;

import junit.framework.TestCase;

import org.junit.Before;

import setting.GeocodeSettings;

public class TestAPIManager extends TestCase {

	private static APIManager api = null;

	@Before
	public void setUp() {
		// CX^X𐶐
		GeocodeSettings settings = new GeocodeSettings();
		settings.readConfigFile();
		// DB̐ݒiłj
		api = new APIManager(settings);
	}

	/**
	 * L[nXg擾ł邩̃eXg
	 */
	public void testSearchLocation() {
		// nȂꍇA̒n擾ł邩
		List<String> locationNames = api.getSearchList("");
		assertEquals(1, locationNames.size());
		assertEquals("", locationNames.get(0));
		// nꍇA̒nXg擾ł邩
		locationNames = api.getSearchList("Oc");
		assertEquals(2, locationNames.size());
		assertEquals("Ocwij", locationNames.get(0));
		assertEquals("OcwiɁj", locationNames.get(1));
		// nȂꍇAn擾Ȃ
		assertNull(api.getSearchList(""));
	}

	/**
	 * nn擾ł邩
	 */
	public void testLocation() {
		// nꍇAnԂ
		GeoData geoData = api.getLocation("Ocij");
		assertEquals("Ocij",geoData.getLocationName());
		assertNotNull(geoData.getLatitude());
		assertNotNull(geoData.getLongitude());
		// nȂꍇAn͋
		geoData = api.getLocation("qwerty");
		assertEquals("qwerty",geoData.getLocationName());
		assertNull(geoData.getLatitude());
		assertNull(geoData.getLongitude());
	}
}
